var getServiceParametersNames = function(beforeJsonStr, afterJsonStr, state) {
	var serviceParms = [];
	var isMatch;

	var beforeObj = JSON.parse(beforeJsonStr);
	var afterObj = JSON.parse(afterJsonStr);

	var beforeObjArr = beforeObj['service-parms'];
	var afterObjArr = afterObj['service-parms'];

	for(var i = 0; i < beforeObjArr.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < afterObjArr.length; j++)
		{
			if(beforeObjArr[i]['display-name'] == afterObjArr[i]['display-name'])
			{
				if(beforeObjArr[i]['value'] != afterObjArr[i]['value'])
				{
					if(state == "after")
					{
						serviceParms.push(afterObjArr[i]['display-name']);
					}
					else if(state == "before")
					{
						serviceParms.push(beforeObjArr[i]['display-name']);
					}
					serviceParms.push('\n');
				}
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			serviceParms.push(beforeObj[i]['display-name']);
			serviceParms.push('\n');
		}
	}

	for(var i = 0; i < afterObjArr.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < beforeObjArr.length; j++)
		{
			if(afterObjArr[i]['display-name'] == beforeObjArr[j]['display-name'])
			{
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			serviceParms.push(afterObjArr[i]['display-name']);
			serviceParms.push('\n');
		}
	}

	return serviceParms.join('');
};

var getServiceParametersValues = function(beforeJsonStr, afterJsonStr, state) {
	var serviceParms = [];

	var beforeObj = JSON.parse(beforeJsonStr);
	var afterObj = JSON.parse(afterJsonStr);

	var beforeObjArr = beforeObj['service-parms'];
	var afterObjArr = afterObj['service-parms'];

	for(var i = 0; i < beforeObjArr.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < afterObjArr.length; j++)
		{
			if(beforeObjArr[i]['display-name'] == afterObjArr[i]['display-name'])
			{
				if(beforeObjArr[i]['value'] != afterObjArr[i]['value'])
				{
					if(state == "after")
					{
						serviceParms.push(afterObjArr[i]['value']);
					}
					else if(state == "before")
					{
						serviceParms.push(beforeObjArr[i]['value']);
					}
					serviceParms.push('\n');
				}
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			if(state == "before")
			{
				serviceParms.push(beforeObjArr[i]['value']);
			}
			else if(state == "after")
			{
				serviceParms.push("");
			}
			serviceParms.push('\n');
		}
	}

	for(var i = 0; i < afterObjArr.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < beforeObjArr.length; j++)
		{
			if(afterObjArr[i]['display-name'] == beforeObjArr[j]['display-name'])
			{
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			if(state == "after")
			{
				serviceParms.push(afterObjArr[i]['value']);
			}
			else if(state == "before")
			{
				serviceParms.push("");
			}
			serviceParms.push('\n');
		}
	}

	return serviceParms.join('');
};

var getAccountNamesAt = function(beforeJsonStr, afterJsonStr, state, index, localizer) {
	var names = [];
	var isMatch;

	var beforeObj = JSON.parse(beforeJsonStr);
	var afterObj = JSON.parse(afterJsonStr);

	var beforeObjArr1 = beforeObj['views'][index]['schema-map-filter']['generic-map'];
	var beforeObjArr2 = beforeObj['views'][index]['view-parms'];

	var afterObjArr1 = afterObj['views'][index]['schema-map-filter']['generic-map'];
	var afterObjArr2 = afterObj['views'][index]['view-parms'];

	for(var i = 0; i < beforeObjArr2.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < afterObjArr2.length; j++)
		{
			if(beforeObjArr2[i]['display-name'] == afterObjArr2[j]['display-name'])
			{
				if(beforeObjArr2[i]['value'] != afterObjArr2[j]['value'])
				{
					if(state == "after")
					{
						names.push(afterObjArr2[i]['display-name']);
					}
					else if(state == "before")
					{
						names.push(beforeObjArr2[i]['display-name']);
					}
					names.push('\n');
				}
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			names.push(beforeObjArr2[i]['display-name']);
			names.push('\n');
		}
	}

	for(var i = 0; i < afterObjArr2.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < beforeObjArr2.length; j++)
		{
			if(afterObjArr2[i]['display-name'] == beforeObjArr2[j]['display-name'])
			{
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			names.push(afterObjArr2[i]['display-name']);
			names.push('\n');
		}
	}

	for(var i = 0; i < beforeObjArr1.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < afterObjArr1.length; j++)
		{
			if(beforeObjArr1[i]['view-name'] == afterObjArr1[j]['view-name'])
			{
				if(beforeObjArr1[i]['app-name'] != afterObjArr1[j]['app-name'])
				{
					if(state == "after")
					{
						switch(index) 
						{
						case 0:
							switch(afterObjArr1[i]['view-name']) {
								case 'name':
								case 'description':
								case 'type':
								case 'cost':
								case 'risk':
								case 'collectedUsersOwners':
								case 'userId':
								case 'state':
									names.push(localizer.getString("ACCOUNT" + afterObjArr1[i]['view-name'].toUpperCase())); break;
								default:
									names.push(localizer.getString(afterObjArr1[i]['view-name'].toUpperCase())); break;
							}
							break;

						default:
							names.push(localizer.getString(afterObjArr1[i]['view-name'].toUpperCase())); break;
						}
						//permissions.push(newAfterArr[i]['view-name'].toUpperCase());
					}

					else if(state == "before")
					{
						switch(index) 
						{
						case 0:
							switch(beforeObjArr1[i]['view-name']) {
								case 'name':
								case 'description':
								case 'type':
								case 'cost':
								case 'risk':
								case 'collectedUsersOwners':
								case 'uesrId':
								case 'state':
									names.push(localizer.getString("ACCOUNT" + beforeObjArr1[i]['view-name'].toUpperCase())); break;
								default:
									names.push(localizer.getString(beforeObjArr1[i]['view-name'].toUpperCase())); break;
							}
							break;

						default:
							names.push(localizer.getString(beforeObjArr1[i]['view-name'].toUpperCase())); break;
						}
					}
					names.push('\n');
				}
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			switch(index) 
				{
				case 0:
					switch(beforeObjArr1[i]['view-name']) {
						case 'name':
						case 'description':
						case 'type':
						case 'cost':
						case 'risk':
						case 'collectedUsersOwners':
						case 'uesrId':
						case 'state':
							names.push(localizer.getString("ACCOUNT" + beforeObjArr1[i]['view-name'].toUpperCase())); break;
						default:
							names.push(localizer.getString(beforeObjArr1[i]['view-name'].toUpperCase())); break;
					}
					break;

				default:
					names.push(localizer.getString(beforeObjArr1[i]['view-name'].toUpperCase())); break;
				}
			names.push('\n');
		}

	}

	for(var i = 0; i < afterObjArr1.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < beforeObjArr1.length; j++)
		{
			if(afterObjArr1[i]['view-name'] == beforeObjArr1[j]['view-name'])
			{
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			switch(index) 
				{
				case 0:
					switch(afterObjArr1[i]['view-name']) {
						case 'name':
						case 'description':
						case 'type':
						case 'cost':
						case 'risk':
						case 'collectedUsersOwners':
						case 'userId':
						case 'state':
							names.push(localizer.getString("ACCOUNT" + afterObjArr1[i]['view-name'].toUpperCase())); break;
						default:
							names.push(localizer.getString(afterObjArr1[i]['view-name'].toUpperCase())); break;
					}
					break;

				default:
					names.push(localizer.getString(afterObjArr1[i]['view-name'].toUpperCase())); break;
				}
					
			names.push('\n');
		}
	}

	return names.join('');
};

var getNamesAt = function(beforeJsonStr, afterJsonStr, state, index, localizer) {
	var names = [];
	var isMatch;

	var beforeObj = JSON.parse(beforeJsonStr);
	var afterObj = JSON.parse(afterJsonStr);

	var beforeObjArr1 = beforeObj['views'][index]['schema-map-filter']['generic-map'];
	var beforeObjArr2 = beforeObj['views'][index]['view-parms'];

	var afterObjArr1 = afterObj['views'][index]['schema-map-filter']['generic-map'];
	var afterObjArr2 = afterObj['views'][index]['view-parms'];

	for(var i = 0; i < beforeObjArr2.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < afterObjArr2.length; j++)
		{
			if(beforeObjArr2[i]['display-name'] == afterObjArr2[j]['display-name'])
			{
				if(beforeObjArr2[i]['value'] != afterObjArr2[j]['value'])
				{
					if(state == "after")
					{
						names.push(afterObjArr2[i]['display-name']);
					}
					else if(state == "before")
					{
						names.push(beforeObjArr2[i]['display-name']);
					}
					names.push('\n');
				}
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			names.push(beforeObjArr2[i]['display-name']);
			names.push('\n');
		}
	}

	for(var i = 0; i < afterObjArr2.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < beforeObjArr2.length; j++)
		{
			if(afterObjArr2[i]['display-name'] == beforeObjArr2[j]['display-name'])
			{
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			names.push(afterObjArr2[i]['display-name']);
			names.push('\n');
		}
	}

	for(var i = 0; i < beforeObjArr1.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < afterObjArr1.length; j++)
		{
			if(beforeObjArr1[i]['view-name'] == afterObjArr1[j]['view-name'])
			{
				if(beforeObjArr1[i]['app-name'] != afterObjArr1[j]['app-name'])
				{
					if(state == "after")
					{
						switch(index) 
						{
						case 0:
							switch(afterObjArr1[i]['view-name']) {
								case 'risk':
									names.push(localizer.getString("USER" + afterObjArr1[i]['view-name'].toUpperCase())); break;
								default:
									names.push(localizer.getString(afterObjArr1[i]['view-name'].toUpperCase())); break;
							}
							break;

						case 1:
							switch(afterObjArr1[i]['view-name']) {
								case 'groupId':
									names.push(localizer.getString(afterObjArr1[i]['view-name'].toUpperCase() + "FROMSRC")); break;
								case 'members':
									names.push(localizer.getString("GROUP" + afterObjArr1[i]['view-name'].toUpperCase())); break;
								default:
									names.push(localizer.getString(afterObjArr1[i]['view-name'].toUpperCase())); break;
							}
							break;

						default:
							names.push(localizer.getString(afterObjArr1[i]['view-name'].toUpperCase())); break;
						}
						//permissions.push(newAfterArr[i]['view-name'].toUpperCase());
					}

					else if(state == "before")
					{
						switch(index) 
						{
						case 0:
							switch(beforeObjArr1[i]['view-name']) {
								case 'risk':
									names.push(localizer.getString("USER" + beforeObjArr1[i]['view-name'].toUpperCase())); break;
								default:
									names.push(localizer.getString(beforeObjArr1[i]['view-name'].toUpperCase())); break;
							}
							break;

						case 1:
							switch(beforeObjArr1[i]['view-name']) {
								case 'groupId':
									names.push(localizer.getString(beforeObjArr1[i]['view-name'].toUpperCase() + "FROMSRC")); break;
								case 'members':
									names.push(localizer.getString("GROUP" + beforeObjArr1[i]['view-name'].toUpperCase())); break;
								default:
									names.push(localizer.getString(beforeObjArr1[i]['view-name'].toUpperCase())); break;
							}
							break;

						default:
							names.push(localizer.getString(beforeObjArr1[i]['view-name'].toUpperCase())); break;
						}
					}
					names.push('\n');
				}
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			switch(index) 
				{
				case 0:
					switch(beforeObjArr1[i]['view-name']) {
						case 'risk':
							names.push(localizer.getString("USER" + beforeObjArr1[i]['view-name'].toUpperCase())); break;
						default:
							names.push(localizer.getString(beforeObjArr1[i]['view-name'].toUpperCase())); break;
					}
					break;

				case 1:
					switch(beforeObjArr1[i]['view-name']) {
						case 'groupId':
							names.push(localizer.getString(beforeObjArr1[i]['view-name'].toUpperCase() + "FROMSRC")); break;
						case 'members':
							names.push(localizer.getString("GROUP" + beforeObjArr1[i]['view-name'].toUpperCase())); break;
						default:
							names.push(localizer.getString(beforeObjArr1[i]['view-name'].toUpperCase())); break;
					}
					break;

				default:
					names.push(localizer.getString(beforeObjArr1[i]['view-name'].toUpperCase())); break;
				}
			names.push('\n');
		}

	}

	for(var i = 0; i < afterObjArr1.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < beforeObjArr1.length; j++)
		{
			if(afterObjArr1[i]['view-name'] == beforeObjArr1[j]['view-name'])
			{
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			switch(index) 
				{
				case 0:
					switch(afterObjArr1[i]['view-name']) {
						case 'risk':
							names.push(localizer.getString("USER" + afterObjArr1[i]['view-name'].toUpperCase())); break;
						default:
							names.push(localizer.getString(afterObjArr1[i]['view-name'].toUpperCase())); break;
					}
					break;

				case 1:
					switch(afterObjArr1[i]['view-name']) {
						case 'groupId':
							names.push(localizer.getString(afterObjArr1[i]['view-name'].toUpperCase() + "FROMSRC")); break;
						case 'members':
							names.push(localizer.getString("GROUP" + afterObjArr1[i]['view-name'].toUpperCase())); break;
						default:
							names.push(localizer.getString(afterObjArr1[i]['view-name'].toUpperCase())); break;
					}
					break;

				default:
					names.push(localizer.getString(afterObjArr1[i]['view-name'].toUpperCase())); break;
				}
					
			names.push('\n');
		}
	}

	return names.join('');
};

var getValuesAt = function(beforeJsonStr, afterJsonStr, state, index) {
	var values = [];

	var beforeJsonObj = JSON.parse(beforeJsonStr);
	var afterJsonObj = JSON.parse(afterJsonStr);
	
	var beforeObjArr1 = beforeJsonObj['views'][index]['schema-map-filter']['generic-map'];
	var beforeObjArr2 = beforeJsonObj['views'][index]['view-parms'];

	var afterObjArr1 = afterJsonObj['views'][index]['schema-map-filter']['generic-map'];
	var afterObjArr2 = afterJsonObj['views'][index]['view-parms'];

	for(var i = 0; i < beforeObjArr1.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < afterObjArr1.length; j++)
		{
			if(beforeObjArr1[i]['view-name'] == afterObjArr1[j]['view-name'])
			{
				if(beforeObjArr1[i]['app-name'] != afterObjArr1[j]['app-name'])
				{
					if(state == "after")
					{
						values.push(afterObjArr1[i]['app-name']);
					}
					else if(state == "before")
					{
						values.push(beforeObjArr1[i]['app-name']);
					}
					values.push('\n');
				}
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			if(state == "before")
			{
				values.push(beforeObjArr1[i]['app-name']);
			}
			else if(state == "after")
			{
				values.push("");
			}
			values.push('\n');
		}

	}

	for(var i = 0; i < afterObjArr1.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < beforeObjArr1.length; j++)
		{
			if(afterObjArr1[i]['view-name'] == beforeObjArr1[j]['view-name'])
			{
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			if(state == "after")
			{
				values.push(afterObjArr1[i]['app-name']);
			}
			else if(state == "before")
			{
				values.push("");
			}
			values.push('\n');
		}
	}

	for(var i = 0; i < beforeObjArr2.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < afterObjArr2.length; j++)
		{
			if(beforeObjArr2[i]['display-name'] == afterObjArr2[j]['display-name'])
			{
				if(beforeObjArr2[i]['value'] != afterObjArr2[j]['value'])
				{
					if(state == "after")
					{
						values.push(afterObjArr2[i]['value']);
					}
					else if(state == "before")
					{
						values.push(beforeObjArr2[i]['value']);
					}
					values.push('\n');
				}
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			if(state == "before")
			{
				values.push(beforeObjArr2[i]['value']);
			}
			else if(state == "after")
			{
				values.push("");
			}
			values.push('\n');
		}

	}

	for(var i = 0; i < afterObjArr2.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < beforeObjArr2.length; j++)
		{
			if(afterObjArr2[i]['display-name'] == beforeObjArr2[j]['display-name'])
			{
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			if(state == "after")
			{
				values.push(afterObjArr2[i]['value']);
			}
			else if(state == "before")
			{
				values.push("");
			}
			values.push('\n');
		}
	}

	return values.join('');
};

var getPermissionNamesAt = function(beforeJsonStr, afterJsonStr, state, index, localizer) {
	var permissions = [];
	var isMatch;

	var beforeObj = JSON.parse(beforeJsonStr);
	var afterObj = JSON.parse(afterJsonStr);

	var beforeObjArr1 = beforeObj['views'][index]['schema-map-filter']['generic-map'];
	var beforeObjArr2 = beforeObj['views'][index]['view-parms'];

	var afterObjArr1 = afterObj['views'][index]['schema-map-filter']['generic-map'];
	var afterObjArr2 = afterObj['views'][index]['view-parms'];


	var newBeforeArr = beforeObjArr1.filter(function(e) {
		return !e.hidden;
	});

	var newBeforeArr2 = beforeObjArr2.filter(function(e) {
		return !e.hidden;
	});

	var newAfterArr = afterObjArr1.filter(function(e) {
		return !e.hidden;
	});

	var newAfterArr2 = afterObjArr2.filter(function(e) {
		return !e.hidden;
	});

	for(var i = 0; i < newBeforeArr2.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < newAfterArr2.length; j++)
		{
			if(newBeforeArr2[i]['display-name'] == newAfterArr2[j]['display-name'])
			{
				if(newBeforeArr2[i]['value'] != newAfterArr2[j]['value'])
				{
					if(state == "after")
					{
						permissions.push(newAfterArr2[i]['display-name']);
					}
					else if(state == "before")
					{
						permissions.push(newBeforeArr2[i]['display-name']);
					}
					permissions.push('\n');
				}
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			permissions.push(newBeforeArr2[i]['display-name']);
			permissions.push('\n');
		}

	}

	for(var i = 0; i < newAfterArr2.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < newBeforeArr2.length; j++)
		{
			if(newAfterArr2[i]['display-name'] == newBeforeArr2[j]['display-name'])
			{
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			permissions.push(newAfterArr2[i]['display-name']);
			permissions.push('\n');
		}
	}

	for(var i = 0; i < newBeforeArr.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < newAfterArr.length; j++)
		{
			if(newBeforeArr[i]['view-name'] == newAfterArr[j]['view-name'])
			{
				if(newBeforeArr[i]['app-name'] != newAfterArr[j]['app-name'])
				{
					if(state == "after")
					{
						switch(index) 
						{
						case 0:
							switch(newAfterArr[i]['view-name']) {
								case 'collectedUsersOwners':
								case 'cost':
								case 'risk':
								case 'name':
								case 'description':
								case 'type':
									permissions.push(localizer.getString("PERMISSION" + newAfterArr[i]['view-name'].toUpperCase())); break;
								default:
									permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase())); break;
							}
							break;

						case 1:
							switch(newAfterArr[i]['view-name']) {
								case 'permissionId':
									permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase() + "S")); break;
								default:
									permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase())); break;
							}
							break;

						case 2:
							switch(newAfterArr[i]['view-name']) {
								case 'permissionId':
									permissions.push(localizer.getString("HOLDER" + newAfterArr[i]['view-name'].toUpperCase())); break;
								default:
									permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase())); break;
							}
							break;

						case 3:
							switch(newAfterArr[i]['view-name']) {
								case 'location':
									permissions.push(localizer.getString("APP" + newAfterArr[i]['view-name'].toUpperCase())); break;
								default:
									permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase())); break;
							}
							break;

						case 4:
							switch(newAfterArr[i]['view-name']) {
								case 'description':
								case 'cost':
								case 'risk':
								case 'collectedUsersOwners':
									permissions.push(localizer.getString("ACCOUNT" + newAfterArr[i]['view-name'].toUpperCase())); break;
								case 'childPermissionId':
									permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase() + "FROMSRC")); break;
								case 'parentPermissionId':
									permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase() + "S")); break;
								default:
									permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase())); break;
							}
							break;

						default:
							permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase())); break;
						}
						//permissions.push(newAfterArr[i]['view-name'].toUpperCase());
					}

					else if(state == "before")
					{
						switch(index) 
						{
							case 0:
								switch(newBeforeArr[i]['view-name']) {
									case 'collectedUsersOwners':
									case 'cost':
									case 'risk':
									case 'name':
									case 'description':
									case 'type':
										permissions.push(localizer.getString("PERMISSION" + newBeforeArr[i]['view-name'].toUpperCase())); break;
									default:
										permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase())); break;
									}
								break;

							case 1:
								switch(newBeforeArr[i]['view-name']) {
									case 'permissionId':
										permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase() + "S")); break;
									default:
										permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase())); break;
								}
								break;

							case 2:
								switch(newBeforeArr[i]['view-name']) {
									case 'permissionId':
										permissions.push(localizer.getString("HOLDER" + newBeforeArr[i]['view-name'].toUpperCase())); break;
									default:
										permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase())); break;
								}
								break;

							case 3:
								switch(newBeforeArr[i]['view-name']) {
									case 'location':
										permissions.push(localizer.getString("APP" + newBeforeArr[i]['view-name'].toUpperCase())); break;
									default:
										permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase())); break;
								}
								break;

							case 4:
								switch(newBeforeArr[i]['view-name']) {
									case 'description':
									case 'cost':
									case 'risk':
									case 'collectedUsersOwners':
										permissions.push(localizer.getString("ACCOUNT" + newBeforeArr[i]['view-name'].toUpperCase())); break;
									case 'childPermissionId':
										permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase() + "FROMSRC")); break;
									case 'parentPermissionId':
										permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase() + "S")); break;
									default:
										permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase())); break;
								}
								break;

							default:
								permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase())); break;
						}
					}
					permissions.push('\n');
				}
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			switch(index) {
				case 0:
					switch(newBeforeArr[i]['view-name']) {
						case 'collectedUsersOwners':
						case 'cost':
						case 'risk':
						case 'name':
						case 'description':
						case 'type':
							permissions.push(localizer.getString("PERMISSION" + newBeforeArr[i]['view-name'].toUpperCase())); break;
						default:
							permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase())); break;
						}
						break;

						case 1:
							switch(newBeforeArr[i]['view-name']) {
								case 'permissionId':
									permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase() + "S")); break;
								default:
									permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase())); break;
							}
							break;

						case 2:
							switch(newBeforeArr[i]['view-name']) {
								case 'permissionId':
									permissions.push(localizer.getString("HOLDER" + newBeforeArr[i]['view-name'].toUpperCase())); break;
								default:
									permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase())); break;
							}
							break;

						case 3:
							switch(newBeforeArr[i]['view-name']) {
								case 'location':
									permissions.push(localizer.getString("APP" + newBeforeArr[i]['view-name'].toUpperCase())); break;
								default:
									permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase())); break;
							}
							break;

						case 4:
							switch(newBeforeArr[i]['view-name']) {
								case 'description':
								case 'cost':
								case 'risk':
								case 'collectedUsersOwners':
									permissions.push(localizer.getString("ACCOUNT" + newBeforeArr[i]['view-name'].toUpperCase())); break;
								case 'childPermissionId':
									permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase() + "FROMSRC")); break;
								case 'parentPermissionId':
									permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase() + "S")); break;
								default:
									permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase())); break;
							}
							break;

						default:
							permissions.push(localizer.getString(newBeforeArr[i]['view-name'].toUpperCase())); break;
							}
			permissions.push('\n');
		}

	}

	for(var i = 0; i < newAfterArr.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < newBeforeArr.length; j++)
		{
			if(newAfterArr[i]['view-name'] == newBeforeArr[j]['view-name'])
			{
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			switch(index) {
				case 0:
					switch(newAfterArr[i]['view-name']) {
						case 'collectedUsersOwners':
						case 'cost':
						case 'risk':
						case 'name':
						case 'description':
						case 'type':
							permissions.push(localizer.getString("PERMISSION" + newAfterArr[i]['view-name'].toUpperCase())); break;
						default:
							permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase())); break;
						}
					break;

				case 1:
					switch(newAfterArr[i]['view-name']) {
						case 'permissionId':
							permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase() + "S")); break;
						default:
							permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase())); break;
					}
					break;

				case 2:
					switch(newAfterArr[i]['view-name']) {
						case 'permissionId':
							permissions.push(localizer.getString("HOLDER" + newAfterArr[i]['view-name'].toUpperCase())); break;
						default:
							permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase())); break;
					}
					break;

				case 3:
					switch(newAfterArr[i]['view-name']) {
						case 'location':
							permissions.push(localizer.getString("APP" + newAfterArr[i]['view-name'].toUpperCase())); break;
						default:
							permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase())); break;
					}
					break;

				case 4:
					switch(newAfterArr[i]['view-name']) {
						case 'description':
						case 'cost':
						case 'risk':
						case 'collectedUsersOwners':
							permissions.push(localizer.getString("ACCOUNT" + newAfterArr[i]['view-name'].toUpperCase())); break;
						case 'childPermissionId':
							permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase() + "FROMSRC")); break;
						case 'parentPermissionId':
							permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase() + "S")); break;
						default:
							permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase())); break;
					}
					break;

				default:
					permissions.push(localizer.getString(newAfterArr[i]['view-name'].toUpperCase())); break;
					}
					
			permissions.push('\n');
		}
	}

	return permissions.join('');
};

var getPermissionValuesAt = function(beforeJsonStr, afterJsonStr, state, index) {
	
	var permissions = [];
	var isMatch;

	var beforeObj = JSON.parse(beforeJsonStr);
	var afterObj = JSON.parse(afterJsonStr);

	var beforeObjArr1 = beforeObj['views'][index]['schema-map-filter']['generic-map'];
	var beforeObjArr2 = beforeObj['views'][index]['view-parms'];

	var afterObjArr1 = afterObj['views'][index]['schema-map-filter']['generic-map'];
	var afterObjArr2 = afterObj['views'][index]['view-parms'];


	var newBeforeArr = beforeObjArr1.filter(function(e) {
		return !e.hidden;
	});

	var newBeforeArr2 = beforeObjArr2.filter(function(e) {
		return !e.hidden;
	});

	var newAfterArr = afterObjArr1.filter(function(e) {
		return !e.hidden;
	});

	var newAfterArr2 = afterObjArr2.filter(function(e) {
		return !e.hidden;
	});

	for(var i = 0; i < newBeforeArr.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < newAfterArr.length; j++)
		{
			if(newBeforeArr[i]['view-name'] == newAfterArr[j]['view-name'])
			{
				if(newBeforeArr[i]['app-name'] != newAfterArr[j]['app-name'])
				{
					if(state == "after")
					{
						permissions.push(newAfterArr[i]['app-name']);
					}
					else if(state == "before")
					{
						permissions.push(newBeforeArr[i]['app-name']);
					}
					permissions.push('\n');
				}
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			if(state == "before")
			{
				permissions.push(newBeforeArr[i]['app-name']);
			}
			else if(state == "after")
			{
				permissions.push("");
			}
			permissions.push('\n');
		}

	}

	for(var i = 0; i < newAfterArr.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < newBeforeArr.length; j++)
		{
			if(newAfterArr[i]['view-name'] == newBeforeArr[j]['view-name'])
			{
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			if(state == "after")
			{
				permissions.push(newAfterArr[i]['app-name']);
			}
			else if(state == "before")
			{
				permissions.push("");
			}
			permissions.push('\n');
		}
	}
	
	for(var i = 0; i < newBeforeArr2.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < newAfterArr2.length; j++)
		{
			if(newBeforeArr2[i]['display-name'] == newAfterArr2[j]['display-name'])
			{
				if(newBeforeArr2[i]['value'] != newAfterArr2[j]['value'])
				{
					if(state == "after")
					{
						permissions.push(newAfterArr2[i]['value']);
					}
					else if(state == "before")
					{
						permissions.push(newBeforeArr2[i]['value']);
					}
					permissions.push('\n');
				}
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			if(state == "before")
			{
				permissions.push(newBeforeArr2[i]['value']);
			}
			else if(state == "after")
			{
				permissions.push("");
			}
			permissions.push('\n');
		}

	}

	for(var i = 0; i < newAfterArr2.length; i++)
	{
		isMatch = false;
		for(var j = 0; j < newBeforeArr2.length; j++)
		{
			if(newAfterArr2[i]['display-name'] == newBeforeArr2[j]['display-name'])
			{
				isMatch = true;
				break;
			}
		}
		if(!isMatch)
		{
			if(state == "after")
			{
				permissions.push(newAfterArr2[i]['value']);
			}
			else if(state == "before")
			{
				permissions.push("");
			}
			permissions.push('\n');
		}
	}

	return permissions.join('');
};